//
//  ThumbnailViewController.m
//  puzzler
//
//  Created by kunii on 11/10/02.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ThumbnailViewController.h"


@implementation ThumbnailViewController



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView
{
}
*/

- (void)viewDidLoad
{
    [super viewDidLoad];   
    basegroundView = [[[UIView alloc] initWithFrame:CGRectMake(60, 100, 200, 200)] autorelease];
    basegroundView.backgroundColor = [UIColor blackColor];
    basegroundView.clipsToBounds = YES;
    [self.view addSubview:basegroundView];

    CGRect r = CGRectMake(0, 0, 44, 44);
    for (int i = 0; i < 100; i++) {
        UIView* view = [[UIView alloc]initWithFrame:CGRectInset(r, 4, 4)];
        view.backgroundColor = [UIColor colorWithHue:(float)i / 100.0 
                                          saturation:1 
                                          brightness:1 
                                               alpha:1];
        [basegroundView addSubview:view];
        r = CGRectOffset(r, r.size.width, 0);
        if (r.origin.x > basegroundView.bounds.size.width) {
            r.origin.x = 0;
            r = CGRectOffset(r, 0, r.size.height);
        }
    }
    UISwipeGestureRecognizer* swipeUpGestureRecognizer 
    = [[[UISwipeGestureRecognizer alloc] initWithTarget:self 
                                                 action:@selector(scroll:)] autorelease];
    swipeUpGestureRecognizer.direction = UISwipeGestureRecognizerDirectionUp;
    [basegroundView addGestureRecognizer:swipeUpGestureRecognizer]; 
    UISwipeGestureRecognizer* swipeDownGestureRecognizer 
    = [[[UISwipeGestureRecognizer alloc] initWithTarget:self 
                                                 action:@selector(scroll:)] autorelease];
    swipeDownGestureRecognizer.direction = UISwipeGestureRecognizerDirectionDown;
    [basegroundView addGestureRecognizer:swipeDownGestureRecognizer]; 
}

- (void)scroll:(UISwipeGestureRecognizer*)swipeGestureRecognizer
{
    UISwipeGestureRecognizerDirection direction = swipeGestureRecognizer.direction;
    float scroll_delta = 100;
    if (direction == UISwipeGestureRecognizerDirectionDown) {
        scroll_delta = -100;
    }
    [UIView animateWithDuration:0.5 animations:^(void) {
        basegroundView.bounds = CGRectOffset(basegroundView.bounds, 0, scroll_delta);
    }];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
#define ANIMATION_MODE 1

#if (ANIMATION_MODE == 1)
    basegroundView.bounds = CGRectOffset(basegroundView.bounds, 0, -basegroundView.bounds.origin.y);
    [UIView animateWithDuration:2 animations:^(void) {
        basegroundView.bounds = CGRectOffset(basegroundView.bounds, 0, 500);
    }];
#endif

#if (ANIMATION_MODE == 2)
    basegroundView.frame = CGRectMake(60, 100, 200, 200);
    [UIView animateWithDuration:2 animations:^(void) {
        basegroundView.frame = CGRectInset(basegroundView.frame, 50, 50);
    }];
#endif


#if (ANIMATION_MODE == 3)
    basegroundView.transform = CGAffineTransformIdentity;
    basegroundView.frame = CGRectMake(60, 100, 200, 200);
    basegroundView.bounds = CGRectMake(0, 0, 200, 200);
    [UIView animateWithDuration:2 
                     animations:^(void) {
                         CGAffineTransform form 
                         = CGAffineTransformScale(CGAffineTransformIdentity, 0.5, 0.5);
                         CGAffineTransform transform = CGAffineTransformTranslate(form, -100, -100);
                         basegroundView.transform = transform;
                     }
                     completion:^(BOOL finished) {
                         basegroundView.frame = CGRectMake(basegroundView.frame.origin.x, basegroundView.frame.origin.y, 200, 200);
                     }
     ];
#endif
}
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
